<template>
  <div class="single">
    <article class="container" v-if="article">
      <h1 class="art__title">{{article.titulo}}</h1>
      <div class="row art__data">
        <div class="col-sm-3">
          <p class="separador">Por {{autor.name}}</p>
        </div>
        <div class="col-sm-3">
          <p>{{formatDate(article.created_at)}}</p>
        </div>
      </div>
      <div class="row">
        <ul class="nav justify-content-end text-primary share">
          <li class="nav-item"><a href="#"><i class="fab fa-facebook-square mx-2 fa-2x"></i></a></li>
          <li class="nav-item"><a href="#"><i class="fab fa-twitter-square mx-2 fa-2x"></i></a></li>
          <li class="nav-item"><a href="#"><i class="fab fa-instagram mx-2 fa-2x"></i></a></li>
        </ul>
      </div>
      <div class="barra_ux">
        <div v-html="article.texto" class="text-left art__text fr-view"></div>
      </div>
    </article>
    <section class="lastart container">
      <h2 class="titulo__articulos pl-5 pt-5">Últimos artículos</h2>
      <hr>
      <div class="card-deck">
        <div class="card" style="width: 18rem;" v-for="item in filter" v-bind:key="item.id">
          <img class="card-img-top" :src="item.imagen" alt="Card image cap">
          <div class="card-body">
            <h5 class="card-title">{{item.titulo}}</h5>
            <p class="card-text">{{item.resumen}}</p>
            <router-link :to="{ name: 'Single', params: {id: item.id}}" class="btn mt-4">Leer más</router-link>
          </div>
        </div>
      </div>
    </section>
    <section class="comentarios container">
      <h3 class="text-white section__title">Comentarios</h3>
      <div class="row mt-5">
        <div class="col-sm-2 text-right">
          <i class="fas fa-user-circle fa-7x text-primary"></i>
        </div>
        <div class="col-sm-9">
          <form action="#">
            <div class="form-inline">
              <input v-model="username" class="form-control w-25 mr-2" type="text" placeholder="Nombre">
            </div>
            <textarea v-model="texto" class="form-control mt-3" placeholder="Tu comentario"></textarea>
            <button @click.prevent="addComentario" type="submit" class="btn d-block ml-auto mt-3">Publicar comentario</button>
          </form>
        </div>
      </div>
      <div v-for="comentario in comentarios" v-bind:key="comentario.id" class="media text-white my-5">
        <i class="fas fa-user fa-5x text-primary"></i>
        <div class="media-body ml-4">
          <h5 class="mt-0 text-primary">{{comentario.username}}</h5>
          <h5 class="mt-0 text-primary">{{formatDate(comentario.created_at)}}</h5>
            <div v-html="comentario.texto" class="text-left art__text fr-view"></div>
        </div>
      </div>
    </section>
  </div>
</template>

<script>
import Vue from 'vue'

export default {
  name: 'single',
  data () {
    return {
      article: [],
      autor: [],
      categoria: [],
      comentarios: [],
      article_id: 0,
      username: '',
      texto: '',
      articlesRelated: [],
      filter: []
    }
  },
  mounted () {
    this.getArticle()
    this.getComentario()
    this.getArticlesRelated()
  },
  methods: {
    getArticle: function () {
      let that = this
      Vue.http.get(`${process.env.URL_API}/api/v1/article/${this.$route.params.id}`).then(response => {
        this.article = response.body
      }, response => {
        // error callback
      }).then(function () {
        that.getAutor(that.article._links.autor)
        that.getCategoria(that.article._links.category)
      })
    },
    getArticlesRelated: function () {
      Vue.http.get(`${process.env.URL_API}/api/v1/article`).then(response => {
        this.articlesRelated = response.body
        for (var i = 0; i < 3; i++) {
          this.filter.push(this.articlesRelated[i])
        }
        return this.filter
      }, response => {
        // error callback
      })
    },
    getAutor: function (url) {
      Vue.http.get(`${process.env.URL_API}${url}`).then(response => {
        this.autor = response.body
      }, response => {
        // error callback
      })
    },
    getCategoria: function (url) {
      Vue.http.get(`${process.env.URL_API}${url}`).then(response => {
        this.categoria = response.body
      }, response => {
        // error callback
      })
    },
    getComentario: function (url) {
      Vue.http.get(`${process.env.URL_API}/api/v1/article/${this.$route.params.id}/comment`).then(response => {
        this.comentarios = response.body
      }, response => {
        // error callback
      })
    },
    addComentario: function (url) {
      // añadimos cada comentario a comentarios
      this.comentarios.push({
        username: this.username,
        texto: this.texto
      })
      if (this.username !== '') {
        this.$http.post(`${process.env.URL_API}/api/v1/comments`, {
          username: this.username,
          texto: this.texto,
          article_id: this.$route.params.id
        }).then(response => {
          // error callback
        })
      }
    },
    formatDate: function (text) {
      let myDate = new Date(text)
      return `${myDate.getDate()}/${myDate.getMonth() + 1}/${myDate.getFullYear()} - ${myDate.getHours()}:${(myDate.getMinutes() < 10 ? '0' : '') + myDate.getMinutes()}`
    }
  }
}
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style>
</style>
